#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "ncsa.h"
#include "query.h"

/*
enum ERROR_TYPE {NO_ERROR, DIVISION_BY_ZERO_OR_PARTIAL_FRACTION};

enum ERROR_TYPE error_type = NO_ERROR;

void	errorMessage(enum ERROR_TYPE);
*/

typedef struct s_tag {
	struct s_tag *pt;
	float a;
	float b;
	float theta;
	float r;
} COMPLEX_T;

int
main ( int argc, char **argv ) {
	char  query_string[2048];
	char  root_str[255];
	char  real_str[255];
	char  imaginary_str[255];

int	n, i;
double	pi;
double	a, b, r, theta, dtheta;
COMPLEX_T
	*ptr, *root, blank;

/* initialization */
pi = acos(-1);

/* input */
	setvbuf( stdout, NULL, _IONBF, 0); /* stdout buffering off */
	strcpy(query_string, getenv("QUERY_STRING"));
	get_var(root_str, "root", query_string);
	get_var(real_str, "real", query_string);
	get_var(imaginary_str, "imaginary", query_string);
	
	n = atoi(root_str);
	a = atof(real_str);
	b = atof(imaginary_str);
	if (!n) n=2; /* if root is blank assume square root */

/* computations */
r = sqrt(a*a + b*b);
theta = acos(a/r);
dtheta = 2 * pi/n;

root = malloc(sizeof blank);
ptr = root;
ptr->pt = NULL;
ptr->theta = theta/n;
ptr->r = exp(log(r)/n);
ptr->a = ptr->r * cos (ptr->theta);
ptr->b = ptr->r * sin (ptr->theta);

for (i=1; i<n; i++) {
	ptr->pt = malloc(sizeof blank);
	ptr = ptr->pt;
	ptr->r = root->r;
	ptr->theta = root->theta + i*dtheta;
	ptr->a = ptr->r * cos (ptr->theta);
	ptr->b = ptr->r * sin (ptr->theta);
	ptr->pt = NULL;
}

/* output */
	printf(	"<p><center>"
			"<h1>Roots of complex numbers."
			"</h1></center>\n");
printf("\n<hr><p>");
printf("\n|%lf%+lfi| = ",a,b);
printf("%lf.", r);
printf("\n<br>&theta; = %lf radians.", theta);
printf("\n<br>&#8710; = %lf radians.", dtheta);
printf("\n</p><p>");
switch (n) {
	case 2:
		printf("\n<h1>&#8730;<span style=\"text-decoration:overline\">%lf%+lfi</span> =</h1>",a,b);
		break;
	default:
		printf("\n<h1><sup>%d</sup>&#8730;<span style=\"text-decoration:overline\">%lf%+lfi</span> =</h1>",n,a,b);
		break;
} /* switch */
ptr = root;
printf("\n<ul>");
do {
	printf("\n<li>%.5lf%+.5lfi</li>", 0.0000005+ptr->a, 0.0000005+ptr->b);
	ptr = ptr->pt;
} while (ptr);
printf("</ul><hr>");
printf(
"<img alt=\"[circles]\"  src=\"../images/circles3.gif\">"
"<p>Enter the root you wish to find of a complex number, followed by the<br>"
"real and imaginary components of the complex number.<br>"
"</h2>"
"<hr>"
"<form action=\"../cgi-bin/roots.pl\" >"
"<table>"
"<td><sup><input type=\"text\"  name=\"root\"     size=1 ></sup>&#8730;&nbsp;"
"<input type=\"text\"  name=\"real\" size=4 >+"
"<input type=\"text\"  name=\"imaginary\" size=4 >i"
"</td>"
"</table>"
"</td><tr></table>"
"<input type=\"submit\"                  value=\"submit\" >"
"<input type=\"reset\">"
"</form></center>"
);

/* clean up */
ptr = root;
while (ptr) {
	root = ptr->pt;
	free(ptr);
	ptr = root;
}
return 0;
}

